
/*******************
 * From src: modules/reports/src/js/alert_history.js
 *******************/
$(document).ready(function() {
	var show_all = $('#show_all');
	if(show_all.length === 0) {
		return;
	}

	var show_hide_obj_sel = function() {
		if (this.checked)
			$('.obj_selector').hide();
		else
			$('.obj_selector').show();
	};
	show_all.on('change', show_hide_obj_sel);
	show_hide_obj_sel.call(show_all.get(0));
});



/*******************
 * From src: modules/reports/src/js/common.js
 *******************/
var sla_month_error_color    = 'red';
var sla_month_disabled_color = '#cdcdcd';
var sla_month_enabled_color  = '#fafafa';
$(document).ready(function() {
	$(".fancybox").fancybox({
		'overlayOpacity'        :       0.7,
		'overlayColor'          :       '#ffffff',
		'hideOnContentClick' : false,
		'autoScale':true,
		'autoDimensions': true,
		'onComplete': function(obj) { $($(obj).attr('href')).find('.filter-status').each(filter_mapping_mapping); }
	});

	$('.filter-status').on('change', filter_mapping_mapping).each(filter_mapping_mapping);

	var direct_link_visible = false;
	$('#current_report_params').click(function() {
		// make sure we always empty the field
		$('#link_container').html('');
		if (!direct_link_visible) {
			$('#link_container')
				.html('<form>'+_label_direct_link+' <input class="wide" type="text" value="'
					+ document.location.protocol + '//'
					+ document.location.host
					+ $('#current_report_params').attr('href')
					+ '"></form>')
				.css('position', 'absolute')
				.css('top', this.offsetHeight + this.offsetTop + 5)
				.css('right', '0')
				.show();
				direct_link_visible = true;
		} else {
			$('#link_container').hide();
			direct_link_visible = false;
		}
		return false;
	});

	$('#save_report').click(function() {
		if (!direct_link_visible) {
			$('#save_report_form')
				.css('position', 'absolute')
				.css('top', this.offsetHeight + this.offsetTop + 5)
				.css('right', '0')
				.show()
				.find('input[name=report_name]')
					.map(function() {
						var input = this;
						if(input.value == "") {
							input.focus();
						}
					});
				direct_link_visible = true;
		} else {
			$('#save_report_form').hide();
			direct_link_visible = false;
		}
		return false;
	});

	$("#report_id").bind('change', function() {
		$("#saved_report_form").trigger('submit');
	});

	$('.save_report_btn').parents('form').submit(function(ev) {
		ev.preventDefault();
		var form = $(this);
		var btn = form.find('.save_report_btn');
		btn.after(loadimg_sml);
		$.ajax({
			url: form[0].action,
			type: form[0].method,
			data: form.serialize(),
			complete: function() {
				btn.parent().find('img:last').remove();
			},
			success: function(data, status_msg, xhr) {
				if (data == null) {
					$.notify(_reports_error + ": " + xhr.responseText, {'sticky': true});
					return;
				}
				Notify.message(data.status_msg, {type: "success"});
				if (!btn[0].form.report_id)
					$('form').append('<input type="hidden" name="report_id" value="'+data.report_id+'"/>');
				$('#save_report_form').hide();
			},
			error: function(data) {
				var resp;
				try {
					resp = $.parseJSON(data.responseText).error;
				} catch (ex) {
					resp = "Unknown error";
				}
				$.notify(_reports_error + ": " + resp, {'sticky': true});
				btn.parent().find('img:last').remove();
			},
			dataType: 'json'
		});
	});

	$(document).on('change', '#report_type', function( e ) {

		set_selection();
		var filterable = jQuery.fn.filterable.find( $('select[name="objects[]"]') ),
			type = e.target.value.replace( /s$/, "" );

		var url = _site_domain + _index_page;
		url += '/listview/fetch_ajax?query=[' + type + 's] all&columns[]=key&limit=1000000';

		if ( filterable ) {
			$.ajax({
				url: url,
				dataType: 'json',
				error: function( xhr ) {
					console.log( xhr.responseText );
				},
				success: function( data ) {

					var names = [];

					for ( var i = 0; i < data.data.length; i++ ) {
						names.push( data.data[ i ].key );
					}

					filterable.data = new Set( names );
					filterable.reset();

				}
			});
		}

	});

	$(document).on('change', '#start_year, #end_year',function () {
		var start = 0;
		var end = 11;
		if (check_custom_months.start_date == undefined || check_custom_months.end_date == undefined) {
			return;
		}
		if (this.value == check_custom_months.start_date.getFullYear()) {
			start = check_custom_months.start_date.getMonth();
		}
		if (this.value == check_custom_months.end_date.getFullYear()) {
			end = check_custom_months.end_date.getMonth();
		}
		var html = '<option></option>';
		for (i = start; i <= end; i++) {
			html += '<option value="' + (i+1) + '">' + Date.monthNames[i] + '</option>';
		}
		if (this.id == 'start_year')
			$('#start_month').html(html);
		else
			$('#end_month').html(html);
	});

	$('#start_year, #end_year, #start_month, #end_month').on('change', check_custom_months);
	$("#delete_report").click(confirm_delete_report);

	$(document).on('submit', '.report_form', function() {
		$('.filter-status:visible:checked', this).each(function() {
			$('#' + $(this).data('which')).find('input, select').attr('name', '');
		});
		$('.filter-status:not(:visible)', this).each(function() {
			$('#' + $(this).data('which')).find('input, select').attr('value', '-2');
		});
		return check_form_values();
	});
	$('#report_type').on('change', set_selection);
	set_selection();
});

function init_datepicker()
{
	// datePicker Jquery plugin
	var datepicker_enddate = (new Date()).asString();
	$('.date-pick').datePicker({clickInput:true, startDate:_start_date, endDate:datepicker_enddate});
	$('#cal_start').on(
		'dpClosed',
		function(e, selectedDates)
		{
			var d = selectedDates[0];
			if (d) {
				d = new Date(d);
				$('#cal_end').dpSetStartDate(d.asString());
			}
		}
	);
	$('#cal_end').on(
		'dpClosed',
		function(e, selectedDates)
		{
			var d = selectedDates[0];
			if (d) {
				d = new Date(d);
				$('#cal_start').dpSetEndDate(d.asString());
			}
		}
	);
}

function show_calendar(val, update) {
	if (val=='custom') {
		$("#custom_time").show();

		init_datepicker();
		init_timepicker();

		if (update == '') {
			$('input[name=start_time]').attr('value', '');
			$('input[name=end_time]').attr('value', '');
		}

		if ($('#month_1').length) {
			check_custom_months();
		}
	} else {
		$("#custom_time").hide();
	}
}

function set_selection() {
	var val = $('#report_type').val();
	if ($.inArray(val, ['servicegroups', 'hostgroups', 'services', 'hosts']) === -1)
		val = 'hostgroups'; // Why? Because I found it like this
	$('.object-list-type').text(val);
	$('*[data-show-for]').hide();
	$('*[data-show-for~='+val+']').show();
}

function check_form_values(form)
{
	if (!form)
		form = document.documentElement;
	var errors = 0;
	var err_str = '';
	var cur_start = '';
	var cur_end = '';

	if ($("#report_period", form).val() == 'custom') {
		if ($('input[name=type]', form).val() != 'sla') {
			// date validation
			cur_start = Date.fromString($("input[name=cal_start]", form).val());
			var time =  $(".time_start", form).val().split(':');
			cur_start.addHours(time[0]);
			cur_start.addMinutes(time[1]);
			cur_end = Date.fromString($("input[name=cal_end]", form).val());
			time = $(".time_end", form).val().split(':');
			cur_end.addHours(time[0]);
			cur_end.addMinutes(time[1]);
			var now = new Date();
			if (!cur_start || !cur_end) {
				if (!cur_start) {
					errors++;
					err_str += "<li>" + _reports_invalid_startdate + ".</li>";
				}
				if (!cur_end) {
					errors++;
					err_str += "<li>" + _reports_invalid_enddate + ".</li>";
				}
			} else {
				if (cur_end > now) {
					if (!confirm(_reports_enddate_infuture)) {
						return false;
					} else {
						cur_end = now;
					}
				}
			}

			if (cur_end < cur_start) {
				errors++;
				err_str += "<li>" + _reports_enddate_lessthan_startdate + ".</li>";
				$(".datepick-start", form).addClass("time_error");
				$(".datepick-end", form).addClass("time_error");
			} else {
				$(".datepick-start", form).removeClass("time_error");
				$(".datepick-end", form).removeClass("time_error");
			}
		} else {
			// verify that we have years and month fields
			if ($('#start_year', form).val() == '' || $('#start_month', form).val() == ''
			|| $('#end_year', form).val() == '' || $('#end_month', form).val() == '') {
				errors++;
				//@@@Fixme: Add translated string
				err_str += "<li>Please select year and month for both start and end. ";
				err_str += "<br />Please note that SLA reports can only be generated for previous months</li>";
			}
			else {
				// remember: our months are 1-indexed
				cur_start = new Date(0);
				cur_start.setYear($("select[name=start_year]", form).val());
				cur_start.addMonths(Number($("select[name=start_month]", form).val()) - 1);

				cur_end = new Date(0);
				cur_end.setYear($("select[name=end_year]", form).val());
				cur_end.addMonths(Number($("select[name=end_month]", form).val()));
			}

			if (cur_end < cur_start) {
				errors++;
				err_str += "<li>" + _reports_enddate_lessthan_startdate + ".</li>";
				$(".datepick-start", form).addClass("time_error");
				$(".datepick-end", form).addClass("time_error");
			} else {
				$(".datepick-start", form).removeClass("time_error");
				$(".datepick-end", form).removeClass("time_error");
			}
		}
	}

	if ($('input[name=report_mode]:checked', form).val() != 'standard' && !$('#show_all', form).is(':checked') && $("[name=objects\\[\\]]", form).is('select') && $('[name=objects\\[\\]] option', form).length == 0) {
		errors++;
		err_str += "<li>" + _reports_err_str_noobjects + ".</li>";
	}

	if ($("#enter_sla", form).is(":visible")) {
		// check for sane SLA values
		var red_error = false;
		var max_val = 100;
		var nr_of_slas = 0;

		for (i=1;i<=12;i++) {
			var field_name = 'month_' + i;
			var input = $('input[id="' + field_name + '"]', form);
			var value = input.attr('value');
			value = value.replace(',', '.');
			if (value > max_val || isNaN(value)) {
				input.css('background', sla_month_error_color);
				errors++;
				red_error = true;
			}
			if (value != '') {
				nr_of_slas++;
			}
		}
		if (red_error) {
			err_str += '<li>' + _reports_sla_err_str + '</li>';
		}

		if (nr_of_slas == 0 && !red_error) {
			errors++;
			err_str += "<li>" + _reports_no_sla_str + "</li>";
		}
	}

	// display err_str if any
	if (!errors) {
		$('#response', form).html('');

		$('#response', form).hide();
		return true;
	}

	// clear all style info from progress
	var resp = $('#response', form);
	if (!resp.length)
		resp = $('#response');
	resp.attr("style", "");
	resp.html("<ul class='alert error'>" + err_str + "</ul>");
	window.scrollTo(0,0); // make sure user sees the error message
	return false;
}

// init timepicker once it it is shown
function init_timepicker()
{
	$("#time_start, #time_end").timePicker();
}

function check_custom_months()
{
	var f = $('.report_form').get(0);
	// not SLA?
	if (!f['start_month'])
		return;

	if (check_custom_months.start_date == undefined) {
		check_custom_months.start_date = new Date(0);
		check_custom_months.end_date = new Date();
		$.ajax({
			url:  _site_domain + _index_page + '/sla/custom_start/',
			type: 'GET',
			dataType: 'json',
			success: function(data) {
				if (!data.timestamp) {
					$.notify("Unable to fetch oldest report timestamp: " + data.responseText, {'sticky': true});
				}
				check_custom_months.start_date.setTime(data.timestamp * 1000);
				var html = '<option></option>';
				for (i = check_custom_months.start_date.getFullYear(); i <= check_custom_months.end_date.getFullYear(); i++) {
					html += '<option>' + i + '</option>';
				}
				$('#start_year').html(html);
				$('#end_year').html(html);
			}
		});
	}
	$('#progress').hide();
}

function confirm_delete_report()
{
	var id = $("#report_id").attr('value')

	var is_scheduled = $('#is_scheduled').text()!='' ? true : false;
	var msg = _reports_confirm_delete + "\n";
	var type = $('input[name=type]').attr('value');
	if (!id)
		return;
	if (is_scheduled) {
		msg += _reports_confirm_delete_warning;
	}
	msg = msg.replace("this saved report", "the saved report '"+$('#report_id option[selected=selected]').text()+"'");
	if (confirm(msg)) {
		$(this).after(loadimg_sml);
		$.ajax({
			url: _site_domain + _index_page + '/' + _controller_name + '/delete/',
			type: 'POST',
			data: {'report_id': id, csrf_token: _csrf_token},
			complete: function() {
				$(loadimg_sml).remove();
			},
			success: function(data) {
				var a = document.createElement("a");
				a.href = window.location.href;
				if(a.search && a.search.indexOf("report_id="+id) !== -1) {
					window.location.href = a.search.replace(new RegExp("report_id="+id+"&?"), "");
				}
			},
			error: function(data) {
				var msg;
				try {
					msg = $.parseJSON(data.responseText).error;
				} catch (ex) {
					msg = "Unknown error";
				}
				$.notify("Failed to delete report: " + msg, {'sticky': true});
			},
			dataType: 'json'
		});
	}
}

function filter_mapping_mapping()
{
	if ($(this).is(':checked'))
		$('#' + $(this).data('which')).hide();
	else
		$('#' + $(this).data('which')).show();
	// when checking if the child is visible, the container must be visible
	// or we'd be checking the wrong thing.
	$(this).siblings('.configure_mapping').show();
	if (!$(this).siblings('.configure_mapping').find('.filter_map:visible').length)
		$(this).siblings('.configure_mapping').hide();
}



/*******************
 * From src: modules/reports/src/js/generated/ninja_manifest.js
 *******************/
// 
// NOTE!
// 
// This is an auto generated file. Changes to this file will be overwritten!
// 
if(typeof(ninja_manifest) === "undefined") {
ninja_manifest = {}
}
$.extend(true, ninja_manifest, {"lsfilter_renderers":{"table":["modules\/reports\/media\/js\/lsfilter_renderer_table.in.js"]},"orm_structure":{"saved_reports":{"id":["int"],"type":["string"],"report_name":["string"],"created_by":["string"],"created_at":["time"],"updated_by":["string"],"updated_at":["time"]}},"orm_table_classes":{"saved_reports":{"object":"SavedReport_Model","set":"SavedReportSet_Model","pool":"SavedReportPool_Model"}}});



/*******************
 * From src: modules/reports/src/js/histogram.js
 *******************/
$(document).ready(function() {
	// since we bundle our javascript to be included in all pages, we need
	// to safeguard against this piece of code being called globally
	if($("#histogram_graph").length === 0) {
		return;
	}

	var get_label = function(x) {
		return graph_xlables[x];
	};
	var showTooltip = function(x, y, contents) {
		$('<div id="tooltip">' + contents + '</div>').css( {
			position: 'absolute',
			display: 'none',
			top: y + 5,
			left: x + 5,
			border: '1px solid #fdd',
			padding: '2px',
			'background-color': '#fee',
			opacity: 0.80
		}).appendTo("body").fadeIn(200);
	};
	var previousPoint = null;
	$("#histogram_graph").bind("plothover", function (event, pos, item) {
		$("#x").text(pos.x.toFixed(2));
		$("#y").text(pos.y.toFixed(2));

		if (item) {
			if (previousPoint != item.datapoint) {
				previousPoint = item.datapoint;

				$("#tooltip").remove();
				var x = item.datapoint[0].toFixed(0),
				y = item.datapoint[1].toFixed(0);

				showTooltip(item.pageX, item.pageY,
				item.series.label + ": " + y + " (" + get_label(x) + ")");
			}
		} else {
			$("#tooltip").remove();
			previousPoint = null;
		}
	});

	$('#show_all_objects').click(function() {
		$('#all_objects').toggle('slow');
	});

	var choiceContainer = $('#choices');
	$.each(datasets, function(key, val) {
		choiceContainer.append('<br/><input type="checkbox" name="' + key +
		'" checked="checked" id="id' + key + '">' +
		'<label for="id' + key + '">'
		+ val.label + '</label>');
	});
	choiceContainer.find("input").click(plotAccordingToChoices);

	function plotAccordingToChoices() {
		var data = [];

		choiceContainer.find("input:checked").each(function () {
			var key = $(this).attr("name");
			if (key && datasets[key])
				data.push(datasets[key]);
		});

		if (data.length > 0)
			$.plot($('#histogram_graph'), data, graph_options);
	}

	plotAccordingToChoices();
});



/*******************
 * From src: modules/reports/src/js/lightbox_edit_settings.js
 *******************/
$(document).ready(function() {
	var edit_settings_url = $('.edit_settings').attr('href');

	var settings = {

		"limit": 1000,
		"selector": "select[data-filterable]",
		"host": window.location.protocol + "//" + window.location.host,

		"datasource": function ( select ) {

			var type = select.attr( 'data-type' ),
				root = settings.host + _site_domain + _index_page;

			return root + '/listview/fetch_ajax?query=[' + type + 's] all&columns[]=key&limit=1000000';

		},

		"collector": function ( select, data ) {

			var names = [];
			for ( var i = 0; i < data.data.length; i++ ) {
				names.push( data.data[ i ].key );
			}
			select.filterable( names );

		},

		"ajax": {
			dataType: 'json',
			error: function( xhr ) {
				console.log( xhr.responseText );
			}
		}

	};

	$(document).on('click', '.edit_settings', function (e) {
		var href = $(this).attr('href');
		var lightbox = LightboxManager.ajax_form_from_href($(this).text(), href);
		e.preventDefault();
		return false;
	});

	$( document ).ajaxComplete(function( event, xhr, settings ) {
		if ( settings.url === edit_settings_url ) {
			setTimeout(function() {
				filterable_init();
				$( ".lightbox-content" ).css({"display": "block"});
				$('.lightbox-content #header').remove();
				$('.lightbox-content').find('.filter-status').each(lightbox_filter_mapping_mapping);
				$('#report_type').trigger('change');
				$('#report_period').trigger('change');
				$('#show_all').removeAttr('checked').trigger('change');
				lightbox_set_report_mode($('#report_mode_form input:checked').val());
			}, 0);
		}
	});

	$(document).on('change', '#report_period', function() {
		var val = $('#report_period').val();
		show_calendar(val);
	});

	$(document).on('change', '#show_all', function( e ) {
		if ($(this).is(':checked'))
			$('.obj_selector').hide();
		else
			$('.obj_selector').show();
	});

	function selectload ( index, element ) {

		var select = $( element );

		if ( select.attr( 'data-type' ) ) {

			settings.ajax.success = function ( data ) {
				settings.collector( select, data );
			};

			settings.ajax.url = settings.datasource( select );
			$.ajax( settings.ajax );

		} else if (select.length) {

			var options = $.map( select.children(), function( option ) {
				return option.text;
			});

			select.children().each( function() {
				if (!$(this).attr('selected')) {
					select.find('option[value="' + this.text + '"]').remove();
				}
			} );

			select.filterable( options );

		}

	}

	function filterable_init() {
		var selects = $(settings.selector );
		selects.each(selectload);
	}

	function lightbox_filter_mapping_mapping() {
		if ($(this).is(':checked'))
			$('#' + $(this).data('which')).hide();
		else
			$('#' + $(this).data('which')).show();
		// when checking if the child is visible, the container must be visible
		// or we'd be checking the wrong thing.
		$(this).siblings('.lightbox-content .configure_mapping').show();
		if (!$(this).siblings('.lightbox-content .configure_mapping').find('.lightbox-content .filter_map:visible').length)
			$(this).siblings('.lightbox-content .configure_mapping').hide();
	}

	function lightbox_set_report_mode(type) {
		switch (type) {
			case 'standard':
				$('.lightbox-content .standard').show();
				$('.lightbox-content .custom').remove();
				break;
			case 'custom':
				$(".lightbox-content .standard").remove();
				$('.lightbox-content .custom').show();
				break;
		}
	}
});



/*******************
 * From src: modules/reports/src/js/lsfilter_renderer_table.js
 *******************/
/*******************************************************************************
 * Table renderer
 ******************************************************************************/

listview_renderer_table.saved_reports = {
	"type" : {
		"header" : _('Type'),
		"depends" : [ 'type' ],
		"sort" : [ 'type asc' ],
		"cell" : function(args) {
			return $('<td />').text(args.obj.type);

		}
	},
	"name" : {
		"header" : _('Name'),
		"depends" : [ 'report_name', 'type', 'id' ],
		"sort" : [ 'report_name asc' ],
		"cell" : function(args) {
			var cell = $('<td />').append(link(args.obj.type + '/generate', {
				report_id : args.obj.id
			}).text(args.obj.report_name));
			return cell;
		}
	},
	"created_by" : {
		"header" : _('Created by'),
		"depends" : [ 'created_by' ],
		"sort" : [ 'created_by asc' ],
		"cell" : function(args) {
			var cell = $('<td />');
			if (args.obj.created_by !== undefined) {
				cell.text(args.obj.created_by);
			} else {
				cell.text(_('N/A'));
			}
			return cell;
		}
	},
	"created_at" : {
		"header" : _('Created at'),
		"depends" : [ 'created_at' ],
		"sort" : [ 'created_at asc' ],
		"cell" : function(args) {
			var cell = $('<td />');
			if (args.obj.created_at !== undefined) {
				cell.text(format_timestamp(args.obj.created_at));
			} else {
				cell.text(_('N/A'));
			}
			return cell;
		}
	},
	"modified_by" : {
		"header" : _('Modified by'),
		"depends" : [ 'modified_by' ],
		"sort" : [ 'modified_by asc' ],
		"cell" : function(args) {
			var cell = $('<td />');
			if (args.obj.modified_by !== undefined) {
				cell.text(args.obj.modified_by);
			} else {
				cell.text(_('N/A'));
			}
			return cell;
		}
	},
	"modified_at" : {
		"header" : _('Modified at'),
		"depends" : [ 'modified_at' ],
		"sort" : [ 'modified_at asc' ],
		"cell" : function(args) {
			var cell = $('<td />');
			if (args.obj.modified_at !== undefined) {
				cell.text(format_timestamp(args.obj.modified_at));
			} else {
				cell.text(_('N/A'));
			}
			return cell;
		}
	},
	"actions" : {
		"header" : _('Actions'),
		"depends" : [ 'type', 'id', 'report_name' ],
		"sort" : false,
		"cell" : function(args) {
			var cell = $('<td />');

			cell.append(icon16('delete', 'Delete ' + args.obj.report_name,
					link(args.obj.type + '/delete', {
						report_id : args.obj.id
					}).addClass('link_ajax_refresh')));
			return cell;
		}
	},
};



/*******************
 * From src: modules/reports/src/js/reports.js
 *******************/
$(document).ready(function() {
	// reset options and reload page
	$('#new_report').click(function() {
		var current_report = $('input[name=type]').val();
		var base_uri = _site_domain + _index_page + '/' + _current_uri;
		var uri_xtra = current_report == 'avail' ? '' : '?type=sla';
		self.location.href = base_uri + uri_xtra;
	});

	$('#include_trends').click(function() {
		if (this.checked) {
			$('#include_trends_scaling').attr('disabled', false);
		} else {
			$('#include_trends_scaling').attr('disabled', true);
			$('#include_trends_scaling').attr('checked', false);
		}
	});

	$("#report_period").bind('change', function() {
		show_calendar($(this).attr('value'));
	});
	show_calendar($("#report_period").attr('value'));

	$('.autofill').click(function() {
		var the_val = $(this).siblings('input').val();
		if (the_val!='') {
			if (!confirm(_reports_propagate.replace('this value', the_val+'%'))) {
				return false;
			}
			set_report_form_values(the_val);
		} else {
			if (!confirm(_reports_propagate_remove)) {
				return false;
			}
			set_report_form_values('');
		}
	});

	$("#new_schedule_btn").click(function() {$('.schedule_error').hide();})

	$('#filename').blur(function() {
		// Make sure the filename is explicit by adding it when focus leaves input
		var input = $(this);
		var filename = input.val();
		if(!filename) {
			return;
		}
		if(!filename.match(/\.(csv|pdf)$/)) {
			filename += '.pdf';
		}
		input.val(filename);
	});

	$('#include_trends').live('click', function(ev) {
		if (ev.target.checked)
			$('.trend_options').show();
		else
			$('.trend_options').hide();
	});

	$('#sla_report_id').on('change', function(ev) {
		var sla_id = $(this).attr('value');
		if (!sla_id) {
			// don't try to fetch sla values when we have no id
			return;
		}
		show_progress('progress', _wait_str);
		var url = _site_domain + _index_page + '/sla/per_month_sla_for_report';
		$.ajax({
			url: url,
			data: {
				sla_id: sla_id,
				csrf_token: _csrf_token
			},
			complete: function() {
				$('#progress').hide();
			},
			error: function() {
				$.notify(_reports_error + ': Unable to fetch saved sla values...', {'sticky':true});
			},
			success: function(data) {
				for (var i = 0; i < data.length; i++) {
					var input = $('#month_' + i);
					if (!data[i]) {
						input.val('');
					} else {
						input.val(data[i]);
					}
				}
				$('.sla_values').show();
			},
			dataType: 'json'
		});
	});
});

// Propagate sla values
function set_report_form_values(the_val)
{
	for (i=1;i<=12;i++) {
		var field_name = 'month_' + i;
		var input = $("#"+field_name);
		input.attr('value', the_val);
	}
}



/*******************
 * From src: modules/reports/src/js/schedule.js
 *******************/
function remove_scheduled_str(in_str)
{
	in_str = in_str.replace(/\*/g, '');
	in_str = in_str.replace(" ( " + _scheduled_label + " )", '');
	return in_str;
}

function create_filename()
{
	if (!$('#saved_report_id option:selected').val()) {
		$('input[name=filename]').val('');
		return false;
	}
	var new_filename = $('#saved_report_id option:selected').text();
	new_filename = remove_scheduled_str(new_filename);
	if($('#sch-repeat-text-box option:selected').text() == "Day"){
		var selected_text = "Daily";
	}else{
		var selected_text = $('#sch-repeat-text-box option:selected').text() + "ly";
	}
	new_filename += '_' + selected_text + '.pdf';
	new_filename = new_filename.replace(/ /g, '_');
	$('input[name=filename]').val(new_filename);
	return true;
}

function fill_saved_reports() {
	var report_type = this.value;
	$.ajax(
		_site_domain + _index_page + "/schedule/list_by_type/"+report_type,
		{
			error: function(xhr) {
				$.notify(_reports_error + ": " + xhr.responseText, {'sticky': true});
		},
			success: function(response) {
				var saved_reports = document.getElementById("saved_report_id");
				var default_opt = saved_reports.children[0];
				saved_reports.length = 1;
				var options = document.createDocumentFragment();
				for(var i = 0; i < response.length; i++) {
					var option = document.createElement("option");
					var result = response[i];
					option.appendChild(document.createTextNode(result.report_name));
					option.setAttribute("value", result.id);
					options.appendChild(option);
				}
				saved_reports.appendChild(options);
				create_filename();
			},
			dataType: 'json'
		}
	);
}

$(document).ready(function() {
	if($('#scheduled_avail_reports').length === 0) {
		// This javascript is included in all pages as part of a
		// bundle. We must however only execute the following code on
		// the "Shedule report" page, which is why this check exists.
		return;
	}
	$("#saved_report_id, #period").change(create_filename);
	fill_scheduled();
	setup_editable();

		// delete single schedule
	$('body').on('click', '.delete_schedule', schedule_delete);
	$('body').on('click', '.send_report_now', send_report_now);

	$("#type").change(fill_saved_reports).each(fill_saved_reports);

	$('#new_schedule_report_form').submit(function(ev) {
    	ev.preventDefault();
        var repeat_time = $('#schedule-report-sendtime').val();
		var repeat_every_no = $('#sch-repeat-no-box').val();
		var repeat_every_text = $('#sch-repeat-text-box').val();
		var repeat_week_day = [];
		$('input[name="week_on_day[]"]:checked').each(function(){
		  repeat_week_day.push(JSON.parse($(this).val()));
		})
		repeat_week_day = JSON.stringify(repeat_week_day);
		var repeat_month_day = $('input[name=sch-month-on]:checked').val();
		var repeat_period = JSON.stringify({"no": + repeat_every_no, "period_id": repeat_every_text});
		var repeat_on = JSON.stringify({"day_no":1});
		if(repeat_every_text == 1){
		  var repeat_on = repeat_week_day;
		}
		if(repeat_every_text == 2) {
		  var repeat_on = repeat_month_day;
		}
		var rep_type_str = $('#type option:selected').val();

        var recipients = $.trim($('#recipients').val());
        if (recipients.indexOf('@') === -1) {
                $.notify(_reports_invalid_email, {'sticky': true, type: 'error'});
                return false;
        }

        if(!validate_form()) {
                return false;
        }
        show_progress('progress', _wait_str);
		$.ajax({
			url: _site_domain + _index_page + '/schedule/schedule',
			type: 'POST',
			data: {
				report_id: 0,
                type: $('#type').val(),
                saved_report_id: $('#saved_report_id').val(),
                period: repeat_every_text,
                recipients: recipients,
                filename: $('#filename').val(),
                description: $('#description').val(),
                attach_description: $('#attach_description').val(),
                local_persistent_filepath: $.trim($('#local_persistent_filepath').val()),
                report_time: repeat_time,
                report_on: repeat_on,
                report_period: repeat_period,
                csrf_token: _csrf_token
			},
			complete: function() {
				$('#progress').hide();
				// make sure we hide message about no schedules and show table headers
				$('#' + rep_type_str + '_no_result').hide();
				$('#' + rep_type_str + '_headers').show();
			},
			error: function(data) {
				Notify.message(data.responseText, {type: "error"});
			},
			success: function(data) {
				var rep_type = $('#type').attr('value');
				var saved_report_id = $('#saved_report_id').attr('value');
				var report_name = $('#saved_report_id option:selected').text();
				var period_str = $('#period option:selected').text();
				var recipients = ($('#recipients').attr('value')).replace(/,/g, ', ');
				var filename = $('#filename').attr('value');
				var local_persistent_filepath = $('#local_persistent_filepath').attr('value');
				var description = $('#description').attr('value');
				var attach_description = $('#attach_description').attr('value');
				create_new_schedule_rows(data.id, rep_type, report_name, saved_report_id, period_str, recipients, filename, local_persistent_filepath, description, attach_description, repeat_time, repeat_on, repeat_period)
                setup_editable();
                $('#new_schedule_report_form').get(0).reset();
                $('#sch-week-opt span').each(function(){
                        $(this).css("background-color","transparent").css("color","black");
                });
                $('#sch-on').hide();
                $('#sch-week-opt').hide();
                $('#sch-month-opt').hide();

				Notify.message(_reports_schedule_create_ok, {type: "success"});
			},
			dataType: 'json'
		});
	});
});

function schedule_delete(ev)
{
	ev.preventDefault();
	if (!confirm(_reports_confirm_delete_schedule)) {
		return false;
	}

	var elem = $(this);
	var type = elem.data('type');
	var schedule_id = elem.data('schedule');
	var report_id = elem.data('report_id');

	var img = $('img', elem);
	var img_src = img.attr('src');
	img.attr('src', loadimg_sml.src);

	$.ajax({
		url:_site_domain + _index_page + '/schedule/delete_schedule',
		data: {'id': schedule_id, csrf_token: _csrf_token},
		complete: function() {
			img.attr('src', img_src);
		},
		success: function(data) {
			Notify.message(data, {type: "success"});
			var table = $('#'+type+'_scheduled_reports_table tbody');
			$('tr#report-'+schedule_id, table).detach();
			if (!$(':visible', table).length)
				$('.no-result', table).show();
		},
		error: function(data) {
			Notify.message(data, {type: "error"});
		},
		type: 'POST',
		dataType: 'json'
	});
}

function send_report_now(ev)
{
	ev.preventDefault();
	var elem = $(this);
	var type = elem.data('type');
	var sched_id = elem.data('schedule');
	var report_id = elem.data('report_id');
	var img = $('img', elem);
	var img_src = img.attr('src');
	img.attr('src', loadimg_sml.src);

	$.ajax({
		url: _site_domain + _index_page + '/schedule/send_now/' + sched_id,
		data: {
			csrf_token: _csrf_token
		},
		type: 'POST',
		complete: function() {
			img.attr('src', img_src);
		},
		success: function(data) {
			Notify.message(data, {type: "success"});
		},
		error: function(data) {
			if(data.responseText) {
				Notify.message(_reports_schedule_send_error + ': ' + data.responseText, {type: "error"});
			} else {
				Notify.message(_reports_schedule_send_error, {type: "error"});
			}
			img.attr('src', img_src);
		},
		dataType: 'json'
	});
}

function setup_editable()
{
	var save_url = _site_domain + _index_page + "/schedule/save_schedule_item/";
	$(".iseditable").editable(save_url, {
		id   : 'elementid',
		name : 'newvalue',
		type : 'text',
		event : 'dblclick',
		width : 'auto',
		height : '14px',
		submit : _ok_str,
		cancel : _cancel_str,
		placeholder:_reports_edit_information,
		submitdata : {'csrf_token': _csrf_token}
	});
	$(".iseditable_txtarea").editable(save_url, {
		indicator : "<img src='" + _site_domain + "application/media/images/loading.gif'>",
		id   : 'elementid',
		name : 'newvalue',
		type : 'textarea',
		event : 'dblclick',
		rows: '3',
		submit : _ok_str,
		cancel : _cancel_str,
		cssclass: "txtarea",
		placeholder:_reports_edit_information,
		submitdata : {'csrf_token': _csrf_token}
	});
	$(".attach_description").editable(save_url, {
		data : {0: "No", 1: "Yes"},
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : _ok_str,
		cancel : _cancel_str,
		submitdata : {'csrf_token': _csrf_token}
	});
}

function format_num_word(no){
  no = parseInt(no);
  switch(no) {
    case 1: return "first"; break;
    case 2: return "second"; break;
    case 3: return "third"; break;
    case 4: return "fourth"; break;
    default: return "last";
  }
}

function create_new_schedule_rows(schedule_id, rep_type, report_name, report_id, report_period_name, recipients, filename, local_persistent_filepath, description, attach_description, report_time, report_on, report_period)
{
	var days_name = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
	var report_time = report_time;
	var report_period = JSON.parse(report_period);
	var report_period_text = '';
	if(report_period.period_id == 3){
        if(report_period.no == 1){
                report_period_text = "Daily at "+report_time;
        }else{
                report_period_text = "Every "+report_period.no+" day at "+report_time;
        }
	}else if(report_period.period_id == 2){
        var report_on =  JSON.parse(report_on);
        if(report_period.no == 1){
            if(report_on.day == "first") {
                report_period_text = "Monthly on the first day of month at " + report_time;
            }
            else if(report_on.day != "last"){
                report_period_text = "Monthly on the "+format_num_word(report_on.day_no)+" "+days_name[report_on.day]+" at "+report_time;
            }else{
                report_period_text = "Monthly on the "+format_num_word(report_on.day_no)+" day of month at "+report_time;
            }
        }else{
            if(report_on.day == "first") {
                report_period_text = "Every " + report_period.no + " months on the first day of month at " + report_time;
            }
            else if(report_on.day != "last"){
                report_period_text = "Every "+report_period.no+" months on the "+format_num_word(report_on.day_no)+" "+days_name[report_on.day]+" at "+report_time;
            }else{
                report_period_text = "Every "+report_period.no+" months on the "+format_num_word(report_on.day_no)+" day of month at "+report_time;
            }
        }
	}else{
	var report_on = JSON.parse(report_on);
    var days = '';
    for(var i = 0; i < report_on.length; i++) {
        if(i == 0){
            days += days_name[report_on[i].day];
        }else if (i > 0 && i < (report_on.length-1)){
            days += ", "+days_name[report_on[i].day];
        }else if(i == (report_on.length-1)){
            days += " and "+ days_name[report_on[i].day];
        }
    }
    if(report_period.no == 1){
    	report_period_text = "Weekly on "+days+" at "+report_time;
    }else{
        report_period_text = "Every "+report_period.no+" week on "+days+" at "+report_time;
    }
}

	var template_row = $('#schedule_template tr');
	var report_type_id = -1;
	for (var i in _report_types_json) {
		if (_report_types_json[i] == rep_type) {
			report_type_id = i;
		}
	}

	template_row = template_row.clone()
	$('#' + rep_type + '_scheduled_reports_table .no-result').hide();
	template_row.attr('id', 'report-'+schedule_id);
	$('.report_name', template_row)
		.attr('id', '' + report_type_id + '.report_id-'+schedule_id)
		.text(report_name.replace(/ \( \*Scheduled\* \)$/, ""));
	$('.description', template_row)
		.attr('id', 'description-'+schedule_id)
		.text(description);
	$('.period_select', template_row)
		.attr('id', 'period_id-'+schedule_id)
		.text(report_period_text);
	$('.recipients', template_row)
		.attr('id', 'recipients-'+schedule_id)
		.text(recipients);
	$('.filename', template_row)
		.attr('id', 'filename-'+schedule_id)
		.text(filename);
	$('.local-path', template_row)
		.attr('id', 'local_persistent_filepath-'+schedule_id)
		.text(local_persistent_filepath);
	$('.attach_description', template_row)
		.attr('id', 'attach_description-'+schedule_id)
		.text(parseInt(attach_description) ? 'Yes' : 'No');
	var actions = $('.action', template_row);
	$('.direct_link', actions).attr('href', _site_domain + _index_page + '/' + rep_type + '/generate?report_id=' + report_id);
	$('.send_report_now, .delete_schedule', actions).data('schedule', schedule_id).data('report_id', report_id).data('type', rep_type);
	var par = $('#' + rep_type + '_scheduled_reports_table tbody');
	if (par.children().last().hasClass('odd'))
		template_row.attr('class', 'even');
	else
		template_row.attr('class', 'odd');
	par.append(template_row);
}

function fill_scheduled() {
	for (var type in _scheduled_reports) {
		if (!_scheduled_reports[type].length) {
			$('#' + type + '_scheduled_reports_table .no-result').show();
			continue;
		}
		for (var i = 0; i < _scheduled_reports[type].length; i++) {
			var report = _scheduled_reports[type][i];
			create_new_schedule_rows(report.id, type, report.reportname, report.report_id, report.periodname, report.recipients, report.filename, report.local_persistent_filepath, report.description, report.attach_description, report.report_time, report.report_on, report.report_period);
		}
	}
}

/**
 * Make sure all values are properly entered
 */
function validate_form(formData, jqForm, options) {
	var recipients = $('input[name=recipients]').attr('value');
	var filename = $('input[name=filename]').attr('value');
	var description = $('input[name=description]').attr('value');
	var saved_report_id = $('input[name=saved_report_id]').attr('value');
	if (!saved_report_id) {
		saved_report_id = $('#saved_report_id').attr('value');
	}
	var report_id = $('input[name=report_id]').attr('value');
	if (report_id == '' || report_id == undefined) {
		report_id = $('#report_id').val();
	}
	var fatal_err_str = _reports_fatal_err_str;// + "<br />";
	$('.schedule_error').hide();

	var err_str = "";
	var errors = 0;

	recipients = recipients.replace(/;/g, ',');
	// @@@FIXME: split multiple addresses on ',' and check each one using regexp
	if ($.trim(recipients) == '') {
		err_str += _reports_schedule_recipient_error + "<br />";
		errors++;
	}
	if (!saved_report_id) {
		$.notify(fatal_err_str, {'sticky': true});
		return false;
	}

	if (errors) {
		/*
		$('#response').attr("style", "");
		$('#response').html("<ul class=\"error\">" + err_str + "</ul>").show();
		*/
		var str = _reports_errors_found + ':<br />' + err_str + '<br />' + _reports_please_correct + '<br />';
		$("#new_schedule_area").prepend("<div id=\"response\" class=\"schedule_err_display\"><ul class=\"error\">" + str + "</ul></div>");
		window.scrollTo(0,0); // make sure user sees the error message
		return false;
	}
	$('.schedule_err_display').remove();
    return true;
}
$(document).ready(function() {
	$('#schedule-report-sendtime').click(function(e){
   	$('.sendtime-quickselect').html(sch_report_quickselect_data($(this).val(),"s"));
   	$('.sendtime-quickselect').show();
    	e.stopPropagation();
  	});

  	$('.sendtime-quickselect').on('click', 'div.time', function() {
    	var selected_time = $(this).html();
    	$('#schedule-report-sendtime').val(selected_time);
    	$('.sendtime-quickselect').hide();
  	});

  	$(document).click(function(){
    	$('.quickselect').hide();
  	});

	$('#sch-repeat-text-box').on('change', function(){
    	var selected = $(this).val();
	    if(selected == 1){
	        $('#sch-month-opt').hide();
	        $('#sch-on').show();
	        $('#sch-week-opt').show();

	    }else if(selected == 2){
	        $('#sch-week-opt').hide();
	        $('#sch-on').show();
	        $('#sch-month-opt').show();
	    }else{
	        $('#sch-week-opt').hide();
	        $('#sch-on').hide();
	        $('#sch-month-opt').hide();
	    }
	    create_filename();
	});

	$('#sch-week-opt').on('click', 'span', function() {
	    var day = $(this).attr("tag");
	    if($('input[tag="week-'+ day +'"]').prop("checked")){
	      	$('input[tag="week-'+ day +'"]').prop("checked",false);
	      	$(this).css("background-color","transparent").css("color","black");
	      	if(!$('input[name="week_on_day[]"]:checked').val()){
	        	$('input[tag="week-'+ day +'"]').prop("checked",true);
	        	$(this).css("background-color","#0277BD").css("color","white");
	      	}
	    }else{
	      	$('input[tag="week-'+ day +'"]').prop("checked",true);
	      	$(this).css("background-color","#0277BD").css("color","white");
	    }
	});

	$('body').on('change', '#sch-on-no-box', function() {
		var selected_day = $('#sch-on-day-box').val();
	  	var selected_day_no = $(this).val();
	  	var sch_month_on_value = JSON.stringify({"day_no":selected_day_no,"day":selected_day});
	      $('#sch-any-day-month').val(sch_month_on_value);
	})

	$('body').on('change', '#sch-on-day-box', function(e) {
	  	var selected_day_no = $('#sch-on-no-box').val();
	  	var selected_day = $(this).val();
	  	var sch_month_on_value = JSON.stringify({"day_no":selected_day_no,"day":selected_day});
	  	$('#sch-any-day-month').val(sch_month_on_value);
	});
});

function sch_report_quickselect_data(time,pre) {
  	time = '00:00';
  	time = time.split(":");
  	var data = '';
  	var hour = parseInt(time[0]);
  	var min = (parseInt(time[1])<30)? 00 : 30;
  	var start = hour+1;
  	var start_i = false;
  	for(i = start; i<24; i++){
    	if(!min && !start_i){
      		data += '<div id="'+pre+''+format_hour(hour)+':30" class="time">'+format_hour(hour)+':30</div>';
      		start_i = true;
      	}
	    data += '<div id="'+pre+''+format_hour(i)+':00" class="time">'+format_hour(i)+':00</div>';
	    data += '<div id="'+pre+''+format_hour(i)+':30" class="time">'+format_hour(i)+':30</div>';
	}
  	for(i = 0; i < start; i++){
    	data += '<div id="'+pre+''+format_hour(i)+':00" class="time">'+format_hour(i)+':00</div>';
    	data += '<div id="'+pre+''+format_hour(i)+':30" class="time">'+format_hour(i)+':30</div>';
  	}
  	return data;
}



/*******************
 * From src: modules/reports/src/js/summary.js
 *******************/
$(document).ready(function() {
	var set_report_mode = function(type) {
		var summary_report_type;
		if (type) {
			summary_report_type = type;
		}
		else {
			//This fix for Cucumber 'Edit Settings' test case
			summary_report_type = getUrlParam('standardreport')?'standard':'custom';
		}
		switch (summary_report_type) {
			case 'standard':
				$('.standard').show();
				$('.custom').hide();
				break;
			case 'custom':
				$('.standard').hide();
				$('.custom').show();
				break;
		}
	};

	$('#report_mode_form input').on('change', function() {
		set_report_mode(this.value);
	});
	set_report_mode($('#report_mode_form input:checked').val());

	$("#report_period").bind('change', function() {
		show_calendar($(this).val());
	});
	show_calendar($('#report_period').val());

	// reset options and reload page
	$('#new_report').click(function() {
		var base_uri = _site_domain + _index_page + '/' + _current_uri;
		self.location.href = base_uri;
	});

	$('.comments').editable(_site_domain + _index_page + '/alert_history/add_comment', {
		data: function(value) {
			var that = $(this);
			that.addClass('editing-comments').on('blur', 'input', function() {
				that.removeClass('editing-comments');
			});
			return $(value).filter('.content').text()
		},
		submitdata: function(value, settings) {
			$(this).removeClass('editing-comments');
			var eventrow = $(this).parents('.eventrow');
			return {
				timestamp: eventrow.data('timestamp'),
				event_type: eventrow.data('statecode'),
				host_name: eventrow.data('hostname'),
				service_description: eventrow.data('servicename'),
				csrf_token: _csrf_token,
				comment: $('input', this).val() // (today) you cannot use value, because it's the original HTML
			}
		},
		width: 'none'
	});

	$('.toggle-long-output').on('click', function() {
		var toggler = $(this);
		var span = toggler.parent().siblings('.alert-history-long-output');
		if (toggler.text() === '+') {
			toggler.text('-');
			span.show();
		} else if (toggler.text() === '-') {
			toggler.text('+');
			span.hide();
		}
	});
});



/*******************
 * From src: modules/reports/src/js/tgraph.js
 *******************/
/**
*	TGraph - JavaScript graphing utility
*/

TGraphEventBinder = function (node, event, callback) {
	if (node.addEventListener) {
		node.addEventListener(event, callback, false);
	} else {
		node.attachEvent('on' + event, callback);
	}
}

var TGraph = function (stops, type, name, max, upscale) {

		/**
		* @param object stops
		*	@param string type = bar
		* @param number width = 500
		* @param number max = 400
		*/

		var w = document.getElementById('tgraph').clientWidth;

		this.upscale = upscale || false;
		this.name = name || 'Graph';
		this.stops = stops;
		this.type = type || 'bar';
		this.width = w * 0.8;
		this.max = max || 400;
		this.blocks = [];

		this.hoverbox = document.createElement('div');
		this.container = document.createElement('div');

		this.container.className = 'tgraph-container';
		this.hoverbox.className = 'tgraph-hoverbox';
		this.label = document.createElement('label');

		this.label.innerHTML = name;
		this.label.className = 'tgraph-label';

		this.container.style.overflow = 'auto';
		this.container.style.width = '100%';
		this.create();
		this.addHover();

		document.body.appendChild(this.hoverbox);

		var tgraph_el = document.getElementById('tgraph');
		while( tgraph_el.firstChild ) { /* Remove all children */
			tgraph_el.removeChild(tgraph_el.firstChild);
		}
		tgraph_el.appendChild(this.container);

};

TGraph.prototype = {

	addHover: function () {

		var that = this;


		TGraphEventBinder(this.container, 'mousemove', function (e) {

			var posx = 0, posy = 0;

			if (e.pageX || e.pageY) {
				posy = e.pageY;
				posx = e.pageX;
			} else {
				posy = document.body.scrollTop + e.clientY;
				posx = document.body.scrollLeft + e.clientX;
			}

			if (posx - that.container.offsetParent.offsetLeft > that.container.offsetWidth / 2) {
				posx -= that.hoverbox.offsetWidth;
				posx -= 10;
			} else {
				posx += 15;
			}

			posy += 15;

			that.hoverbox.style.left = posx + 'px';
			that.hoverbox.style.top = posy + 'px';

		})


		TGraphEventBinder(this.container, 'mouseover', function (e) {

			e = e || window.event;

			if (!e.target) {
				e.target = e.srcElement;
			}

			if (e.target.value) {
				that.hoverbox.style.display = 'block';
				that.hoverbox.innerHTML = e.target.value;
			}

		});

		TGraphEventBinder(this.container, 'mouseout', function (e) {

			e = e || window.event;

			that.hoverbox.style.display = 'none';
			that.hoverbox.innerHTML = '';
		});

	},

	hoverText: function (stop, time) {
		return '<b class="title">' + stop['label'] +'</b><br />'+
			'<small>' + this.parseNiceTime(new Date(time)) + ' - ' +
			this.parseNiceTime(new Date(time + stop.duration)) +
			'</small>' +
			((stop['short']) ? '<br />' + stop['short'] : '');
	},

	formatNumber: function (n) {
		if (n < 10) {
			return '0' + n;
		} else {
			return n;
		}
	},

	parseNiceTime: function (date) {
		return date.getFullYear() +'-'+
			this.formatNumber((date.getMonth() + 1)) + '-' +
			this.formatNumber(date.getDate()) + ' ' +
			this.formatNumber(date.getHours()) + ':' +
			this.formatNumber(date.getMinutes());
	},

	parseNiceTimeHigh: function (date) {
		return date.getFullYear() +'-'+
			this.formatNumber((date.getMonth() + 1)) + '-' +
			this.formatNumber(date.getDate());
	},

	parseNiceTimeSuperHigh: function (date) {
		return this.formatNumber((date.getMonth() + 1)) + '-' +
			this.formatNumber(date.getDate());
	},

	createBlock: function (stop, starttime) {
		var block = document.createElement('div');

		block.style.left = ((starttime / this.max) * 100) + '%';
		block.style.right = (100 - ((starttime + stop.duration) / this.max) * 100) + '%';
		block.style.background = stop.color;
		block.className = 'tgraph-block';

		return block;
	},

	addNote: function (stop, skew) {
		note = document.createElement('div');
		note.className = 'tgraph-note';
		note.style.background = stop['color'];
		note.style.marginTop = (parseInt(note.style.marginTop || '-6', 10) - skew) + 'px';
		note.style.marginLeft = (parseInt(note.style.marginLeft || '-4', 10) + skew) + 'px';
		stop.block.appendChild(note);
	},

	drawScale: function () {

		var line = null,
			graph = document.createElement('div'),
			el = null,
			clear = document.createElement('div'),
			shigh = ((new Date(this.start)).getFullYear() == (new Date(this.start + this.max)).getFullYear());

		clear.style.clear = 'both';
		graph.className = 'tgraph';
		//graph.style.width = this.width + 'px';
		graph.style.height = '40px';
		graph.style.border = 'none';

		clone = this.label.cloneNode(true);
		clone.innerHTML = "";

		for (var i = 0; i <= 6; i += 1) {

			line = document.createElement('div');
			line.className = 'tgraph-time-line';
			line.style.height = (this.height) + 'px';
			line.style.marginTop = '-' + (this.height + 0) + 'px';

			el = document.createElement('div');
			el.style.width = ((1 / 7) * 100) + '%';
			el.className = 'tgraph-time';

			if (shigh) {
				el.innerHTML = '&nbsp;&nbsp;' + this.parseNiceTimeSuperHigh(new Date(this.start + ((this.max / 7) * i)));
			} else {
				el.innerHTML = '&nbsp;&nbsp;' + this.parseNiceTimeHigh(new Date(this.start + ((this.max / 7) * i)));
			}

			el.appendChild(line);

			graph.appendChild(el);
		}

		this.container.appendChild(clear);
		this.container.appendChild(clone);
		this.container.appendChild(graph);

	},

	/**
	 * The subline's sub-blocks all currently have coordinates relative to the line, they must be translated
	 * into coordinates relativeto the subline.
	 * The subline itself should have a width of (length of interruption * 2) and be neatly centered.
	 */
	rescaleSubline: function (subline) {
		var scale_from = parseFloat(subline.style.left.slice(0,-1));
		var scale_to = 100 - parseFloat(subline.style.right.slice(0,-1));
		for (var si = 0; si < subline.children.length; si++) {
			var child = subline.children[si];
			var orig_from = parseFloat(child.style.left.slice(0,-1));
			var orig_to = 100 - parseFloat(child.style.right.slice(0,-1));
			child.style.left = (((orig_from - scale_from) / (orig_to - scale_from)) * 100) + '%';
			child.style.right = (100 - ((orig_to - scale_from) / (orig_to - scale_from)) * 100) + '%';
		}
		subline.style.left = Math.max(0, scale_from - (scale_to - scale_from) / 2) + '%';
		subline.style.right = 100 - Math.min(100, scale_to + (scale_to - scale_from) / 2) + '%';
	},

	create: function () {

		var time = null,
			note = null,
			line = null,
			graph = null,
			lclone = null,
			subline = null,
			clear = document.createElement('div'),
			skew = 0,
			i = 0,
			running_duration = 0;

		clear.style.clear = 'both';
		this.start = this.max * 1000;
		this.height = 0;

		this.max = 0;
		if (this.stops.length > 0) {
			for (i; i < this.stops[0].length; i += 1) {
				this.max += this.stops[0][i].duration * 1000;
			}
		}

		var lastHost = '';

		for (var y = 0; y < this.stops.length; y += 1) {

			graph = document.createElement('div');
			line = document.createElement('div');
			subline = document.createElement('div');
			i = 0;

			graph.className = 'tgraph';
			subline.className = 'tgraph-subline';
			line.className = 'tgraph-block-line';

			var cHost = this.name[y].split(';')[0],
				sName = this.name[y].split(';')[1];

			lclone = this.label.cloneNode(true);

			if (cHost === lastHost) {
				lclone.innerHTML = sName;
			} else {
				lclone.innerHTML = '<strong>' + cHost + '</strong>' + ((sName) ? ' ; ' + sName: '');
			}

			lastHost = cHost;

			time = this.start;
			running_duration = 0;
			laststate = '';

			this.height += 40;

			for (i; this.stops[y] && i < this.stops[y].length; i += 1) {

				this.stops[y][i].duration = this.stops[y][i].duration * 1000;
				this.stops[y][i].index = i;

				this.stops[y][i].block = this.createBlock(this.stops[y][i], running_duration);

				if (this.upscale === true && (this.stops[y][i].duration / this.max) < 0.03 && this.stops[y][i].color != 'transparent') {
					clone = this.stops[y][i].block.cloneNode(true);

					this.stops[y][i].block.style.background = "#333";

					clone.value = this.hoverText(this.stops[y][i], time);
					subline.style.right = this.stops[y][i].block.style.right;
					if (subline.children.length == 0)
						subline.style.left = this.stops[y][i].block.style.left;
					subline.appendChild(clone);
				} else {
					if (subline.children.length > 0) {
						this.rescaleSubline(subline)
						line.appendChild(subline);
						subline = document.createElement('div');
						subline.className = 'tgraph-subline';
					}

					this.stops[y][i].block.value = this.hoverText(this.stops[y][i], time);
				}

				line.appendChild(this.stops[y][i].block);

				time += this.stops[y][i].duration;
				running_duration += this.stops[y][i].duration;

			}
					if (subline.children.length > 0) {
						this.rescaleSubline(subline)
						line.appendChild(subline);
					}

			if (!document.addEventListener) {
				var clear = document.createElement('div');
				clear.style.clear = 'both';
				line.appendChild(clear);
			}

			graph.appendChild(line);
			this.container.appendChild(lclone);
			this.container.appendChild(graph);
			this.container.appendChild(clear.cloneNode(true));

		}

		this.drawScale();

	}

};



/*******************
 * From src: modules/reports/src/js/utils.js
 *******************/
function getUrlParam(name, input_url_param) {
	var name = name.replace('[', '\\[').replace(']', '\\]');
	var regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
	var results = regex.exec(input_url_param?input_url_param:window.location);
	if(results === null) {
		return '';
	} else {
		return results[1];
	}
}


